--BATTLEMOD AND OTHER NETGAME-RELATED CODE--

--cvars
--battlemod mode, can spyro use flameshot?
CV_RegisterVar({
	name = "spyrobattlemode",
	defaultvalue = "0",
	flags = CV_NETVAR,
	PossibleValue = {ActionNone = 0, ActionFlameshot = 1}
})

--flamethrower jettysyn, for the funni admemes
--allows spyro players to use spyro's fire breath as a jettysyn
rawset(_G, "cv_spyro_jettysynfun", CV_RegisterVar({
	name = "spyro_jettysynfun",
	defaultvalue = "0",
	PossibleValue = {Yes = 1, No = 0},
	flags = CV_NETVAR|CV_CHEAT,
}))

local battlemode = CV_FindVar("spyrobattlemode")

-------------
--BATTLEMOD--
-------------
local ScriptLoaded = false
local cv_chasecam = CV_FindVar("chasecam")

--battlemod action init
addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle
		then
		ScriptLoaded = true
		local B = CBW_Battle
		
		--add stuff to chargable/flammable enemy table
		--flammables
		--table.insert(flammableEnemies, MT_BUZZBUDDY)
		table.insert(flammableEnemies, MT_CRAWLAMISSILE)
		table.insert(flammableEnemies, MT_BASHMISSILE)
		table.insert(flammableEnemies, MT_JETJAWMISSILE)
		table.insert(flammableEnemies, MT_SPARRINGDUMMY)
		
		--chargeables
		table.insert(chargeableEnemies, MT_SPARRINGDUMMY)
		
		--bonkables
		table.insert(chargeableBonk, MT_CHESSKNIGHT)
		table.insert(chargeableBonk, MT_CHESSKING)
		table.insert(chargeableBonk, MT_CHESSQUEEN)
		table.insert(chargeableBonk, MT_CHESSPAWN)
		table.insert(chargeableBonk, MT_BASHBOULDER)
		
		--nonflammables
		table.insert(nonflammableEnemies, MT_CHESSKNIGHT)
		table.insert(nonflammableEnemies, MT_CHESSKING)
		table.insert(nonflammableEnemies, MT_CHESSQUEEN)
		table.insert(nonflammableEnemies, MT_CHESSPAWN)
		table.insert(nonflammableEnemies, MT_BASHBOULDER)
		
		--print(flammableEnemies)
		print("\137SPYRO: BattleMod chargeable/flammable enemy table set")
				
		B.Action.SpyroFlameshot = function(mo,doaction,throwring,tossflag)
		--B.Action.SpyroShieldBurst = function(mo,doaction,throwring,tossflag)
			
			local player = mo.player
			local p = mo.player
			--local chasecam_on = cv_chasecam.value
			
			--can we aim?
			--if chasecam_on
			--	p.canaim = 0
			--else
			--	p.canaim = 1
			--end
			
			player.actiontext = "Flameshot"
			player.actionrings = 15
			--Flameshot is a super-brief stream of supeflame fireballs
			--Slightly risky to use due to the dangerous fire the superflame fireballs leave behind
			--That and it doesn't autoaim
			
			if not(B.CanDoAction(player)) then player.actionstate = 0 return end
			
			--neutral initiation state
			if player.actionstate == 0
				if doaction == 1 --and B.CheckRings(player,throwring) == 1 
				and not (player.charging or player.aircharging or player.bannedvars)
					then
					B.PayRings(player)
					player.actionstate = 1
					player.actiontime = 0
					S_StartSound(mo,sfx_s1ae)
				end
			end
			
			--windup state
			if player.actionstate == 1
				player.actiontime = $+1
				
				--stahp
				P_InstaThrust(mo,mo.angle,0)
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale*1,0)
				mo.state = S_PLAY_JUMP
				
				if player.actiontime == 5 then
					player.actionstate = 2
					player.actiontime = 0
				end
			end
			
			--act state, flameshot
			if player.actionstate == 2
				player.actiontime = $+1
				
				--if player.actiontime&3==3 --every 4 tics
				--	then
				--	local p = P_SPMAngle(mo,MT_SPYROFIRESUPER,mo.angle,player.autoaim^^1)
				--	if player.autoaim then
				--		B.AutoAim(mo,mo.angle,45,-1,true,p,p.info.speed,MF_ENEMY|MF_BOSS)
				--	end
				--end
				
				P_SPMAngle(mo, MT_SPYROFIRESUPER, mo.angle, p.canaim, MF2_EXPLOSION)
				S_StartSound(mo, sfx_sflame, mo.player)
				mo.player.sflamecooldown = 9
				
				--recoil
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale*2,false)
				P_InstaThrust(mo,mo.angle+ANGLE_180,mo.scale*6)
				--player.actioncooldown = TICRATE*2
				--B.ApplyCooldown(player,max(0, (TICRATE*3)/2))
				B.ApplyCooldown(player,max(0, TICRATE*2))
				mo.state = S_PLAY_FALL
				player.drawangle = mo.angle
				player.gliding = false
				
				--reset actionstate
				if player.actiontime == 3 then player.actionstate = 0 end
			end
			
		end
		
		--SHIELD BURST ACTION
		local cooldownexplode = 2*TICRATE
		local cooldowndash = TICRATE/2
		local state_shieldburst_windup = 1
		local state_shieldburst_act = 2
		local state_dash_windup = 3
		local state_dash_act = 4
		local ascentrate = FRACUNIT
		local burstspeed = 40*FRACUNIT
		
		B.Action.SpyroShieldBurst_old = function(mo, doaction)
			local p = mo.player
			local shtype = p.powers[pw_shield]
			local shexplode = false
			
			if not(B.CanDoAction(p))
				p.actionstate = 0
				return 
			end
			
			--get shield info
			if shtype == SH_ELEMENTAL
				p.actiontext = "Explosion"
				p.actionrings = 20
				shexplode = true
			elseif shtype == SH_FLAMEAURA
				p.actiontext = "Comet Dash"
				p.actionrings = 5
				shexplode = false
			elseif shtype == SH_WHIRLWIND
				p.actiontext = "Air Push"
				p.actionrings = 10
				shexplode = true
			elseif (shtype & SH_FORCE)
				p.actiontext = "Force Clear"
				p.actionrings = 10
				shexplode = true
			elseif shtype == SH_THUNDERCOIN
				p.actiontext = "Storm Fury"
				p.actionrings = 20
				shexplode = true
			elseif shtype == SH_ATTRACT
				p.actiontext = "Rail Fury"
				p.actionrings = 25
				shexplode = true
			elseif shtype == SH_ARMAGEDDON
				p.actiontext = "Armageddon Blast"
				p.actionrings = 1
				shexplode = true
			end
			
			--neutral initiation state
			if p.actionstate == 0
				if doaction == 1 --and B.CheckRings(player,throwring) == 1 
				and not (p.charging or p.aircharging or p.bannedvars)
					B.PayRings(p)
					p.actionstate = 1
					p.actiontime = 0
					S_StartSound(mo,sfx_s1ae)
					p.gliding = false
				end
			end
			
			--windup
			if p.actionstate == 1
				p.actiontime = $+1
				if shexplode --shield busrts windup
					p.actionstate = state_shieldburst_windup
					P_SetObjectMomZ(mo, ascentrate, false)
					P_InstaThrust(mo, mo.angle, 0)
					mo.state = S_PLAY_ROLL
					if p.actiontime >= 12
						p.actionstate = 2
					end
				else --comet dash windup
					p.actionstate = state_shieldburst_windup
					P_SetObjectMomZ(mo, ascentrate, false)
					P_InstaThrust(mo, mo.angle, 0)
					mo.state = S_PLAY_ROLL
					if p.actiontime >= 5
						p.actionstate = 3
						p.actiontime = 0
					end
				end
				
				--act state, flameshot
				if p.actionstate == 3
					p.actiontime = $+1
					
					--if player.actiontime&3==3 --every 4 tics
					--	then
					--	local p = P_SPMAngle(mo,MT_SPYROFIRESUPER,mo.angle,player.autoaim^^1)
					--	if player.autoaim then
					--		B.AutoAim(mo,mo.angle,45,-1,true,p,p.info.speed,MF_ENEMY|MF_BOSS)
					--	end
					--end
					
					P_SPMAngle(mo, MT_SPYROFIRESUPER, mo.angle, 1)
					S_StartSound(mo, sfx_sflame, mo.player)
					p.sflamecooldown = 9
					
					--recoil
					P_SetObjectMomZ(mo, P_MobjFlip(mo)*mo.scale*2, false)
					P_InstaThrust(mo, mo.angle+ANGLE_180, mo.scale*6)
					--player.actioncooldown = TICRATE*2
					B.ApplyCooldown(p, max(0, (TICRATE*3)/2))
					mo.state = S_PLAY_FALL
					p.drawangle = mo.angle
					p.gliding = false
					
					--reset actionstate
					if p.actiontime == TICRATE*2 then p.actionstate = 0 end
				end
			end
		end
		
		--assign actions
		--B.ActionChar["spyro"] = B.Action.SpyroFlameshot
		
		--set up battlemod vars
		local B = CBW_Battle
		local S = B.SkinVars
		local Act = B.Action
		local G = B.GuardFunc
		
		local xyangle = B.GetCollideRelativeAngle
		local zangle = B.GetZCollideAngle
		
		--priority stuff
		B.SPriority_SpyroGlide = function(mo, other)
			if abs(zangle(mo,other)) > ANGLE_45 or abs(xyangle(mo,other,true)) > ANGLE_45 then return false
			else return true end
		end
		
		B.SPriority_SpyroCharge = function(mo, other)
			if abs(xyangle(mo,other,true)) > ANGLE_45
				return false
			else 
				return true 
			end
		end
		
		B.AddPriorityFunction("spyro_glide", B.SPriority_SpyroGlide)
		B.AddPriorityFunction("spyro_charge", B.SPriority_SpyroCharge)
		
		--B.SetPriority = function(player,atk,def,sfunc,satk,sdef,txt)
		B.Priority_Spyro = function(p)
			if p.gliding
				B.SetPriority(p, 0, 0, "spyro_glide", 0, 1, "gliding body somehow")
			end
			
			if p.charging or p.aircharging
				B.SetPriority(p, 1, 2, "spyro_charge", 1, 2, "charge attack")
			end
			
			if p.supercharging
				B.SetPriority(p, 3, 2, "spyro_charge", 3, 3, "supercharge attack")
			end
		end
		
		--skinvars
		S["spyro"] = {
		flags = SKINVARS_GUARD,
		weight = 105,
		shields = 0,
		--special = Act.SpyroFlameshot,
		special = nil,
		guard_enabled = true,
		guard_frame = 2,
		func_guard_trigger = G.Parry,
		func_priority = B.Priority_FullCommon,
		func_priority_ext = B.Priority_Spyro,
		}
		print("\137SPYRO: BattleMod support initialized")
		
		--disable spyro's snowflake code
		for p in players.iterate
			COM_BufInsertText(p, "spyrosnowflakecode 0")
			--cv_spyrosnowflakecode.value = 0
		end
		print("\137SPYRO: Snowflake code disabled")
	end
	
	--------------------------
	--MAIN BATTLEMOD THINKER--
	--------------------------
	if ScriptLoaded
		--set up battlemod vars
		local B = CBW_Battle
		local S = B.SkinVars
		local Act = B.Action
		local G = B.GuardFunc
		
		for p in players.iterate
			if p.mo and p.mo.skin == "spyro"
				local shtype = p.powers[pw_shield]
				
				--override battleheal sprite (sonic battle collection)
				--the 'continue' sprte that was used looked dumb in this context
				if constantExists("S_PLAY_BATTLEHEAL")
					if p.mo.state == S_PLAY_BATTLEHEAL
						p.mo.sprite2 = SPR2_HEAL
					end
				end
				
				--set action based on cvar
				if battlemode.value == 1
					S["spyro"] = {
					flags = SKINVARS_GUARD,
					weight = 105,
					shields = 0,
					special = Act.SpyroFlameshot,
					--special = nil,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = B.Priority_Spyro,
					}
				else
					S["spyro"] = {
					flags = SKINVARS_GUARD,
					weight = 105,
					shields = 0,
					--special = Act.SpyroFlameshot,
					special = nil,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = B.Priority_Spyro,
					}
				end
				
				--anti swim exhaustion
				if p.exhaustmeter < FRACUNIT
					p.exhaustmeter = FRACUNIT
				end
				
				
				
				--action picker based on shield
				--and it alters the entire skinvars aaaaaa
				/*
				if shtype == SH_ELEMENTAL
					S["spyro"] = {
					weight = 105,
					shields = 1,
					special = Act.SpyroFlameshot,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = nil,
					}
				elseif shtype == SH_FLAMEAURA
					S["spyro"] = {
					weight = 105,
					shields = 1,
					special = Act.SpyroFlameshot,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = nil,
					}
				elseif shtype == SH_WHIRLWIND
					S["spyro"] = {
					weight = 105,
					shields = 1,
					special = Act.TailSwipe,
					--special = Act.SpyroShieldBurst,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = Act.TailSwipe_Priority,
					sprites = {
						S_PLAY_FALLCHARGE
						}
					}
				elseif (shtype & SH_FORCE)
					S["spyro"] = {
					weight = 105,
					shields = 1,
					special = Act.SuperSpinJump,
					--special = Act.SpyroShieldBurst,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = Act.SuperSpinJump_Priority,
					}
				elseif shtype == SH_THUNDERCOIN
					S["spyro"] = {
					weight = 105,
					shields = 1,
					special = Act.EnergyAttack_Priority,
					--special = Act.SpyroShieldBurst,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = nil,
					}
				elseif shtype == SH_ATTRACT
					S["spyro"] = {
					weight = 105,
					shields = 1,
					special = Act.EnergyAttack,
					--special = Act.SpyroShieldBurst,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = EnergyAttack_Priority,
					}
				elseif shtype == SH_ARMAGEDDON
					S["spyro"] = {
					weight = 105,
					shields = 1,
					special = nil,
					--special = Act.SpyroShieldBurst,
					guard_enabled = true,
					guard_frame = 2,
					func_guard_trigger = G.Parry,
					func_priority = B.Priority_FullCommon,
					func_priority_ext = nil,
					}
				end
				*/
			end
		end
	end
end)

----------------
--HURT MESAGES--
----------------

--get the player's team color and re-colors their name to it's team color
--also checks if they're dead if posthumous is true
local function getTeamColoredName(p, posthumous) --(player_t, boolean)
	local funcname = p.name
	
	if G_GametypeHasTeams() --set playername to teamcolor
		if p.ctfteam == 1 --red team
			funcname = "\133" ..$.. "\128"
		end
		if p.ctfteam == 2 --blue team
			funcname = "\132" ..$.. "\128"
		end
	end
	--did he dieded?
	if posthumous and not p.mo.health
		funcname = "The late " .. $
	end
	return funcname
end

--possessive apostrophie alterator thingy, for those national socialists whith a fixation on grammar
local function possessiveFix(noun)
	local out = "'s"
	noun = $ .. "'s"
	
	--check if noun ends with an "s", then suffix either "'" or "'s"
	if string.find(noun, "s's")
		out = "'"
	end
	return out
end

--hit by firebreath
addHook("HurtMsg", function(p, inflictor, src)
	local pname = getTeamColoredName(p)
	local srcname = "someone" --getTeamColoredName(src.player)
	--print(src.target.player.name)
	
	--get inflictor's target's name if the source exists (can't use source itself for some reason)
	if inflictor and inflictor.valid and inflictor.target and inflictor.target.valid and inflictor.target.player
		srcname = getTeamColoredName(inflictor.target.player, true)
	end
	
	if p.mo.health > 0
		print(pname .. " was hit by " .. srcname .. possessiveFix(srcname) .. " fire breath.")
	else
		print(pname .. " is toast from " .. srcname .. possessiveFix(srcname) .. " fire breath.")
	end
	return true
end, MT_SPYROFIRE)

--hit by supeflame
addHook("HurtMsg", function(p, inflictor, src)
	local pname = getTeamColoredName(p)
	local srcname = "someone" --getTeamColoredName(src.player)
	
	--get inflictor's target's name if the source exists (can't use source for some reason)
	if inflictor and inflictor.valid and inflictor.target and inflictor.target.valid and inflictor.target.player
		srcname = getTeamColoredName(inflictor.target.player, true)
	end
	
	if p.mo.health > 0
		print(pname .. " was hit by " .. srcname .. possessiveFix(srcname) .. " superflame.")
	else
		print(pname .. " was blown to bits by " .. srcname .. possessiveFix(srcname) .. " superflame.")
	end
	return true
end, MT_SPYROFIRESUPER)

--hit by eleczap
addHook("HurtMsg", function(p, inflictor, src)
	local pname = getTeamColoredName(p)
	local srcname = "someone" --getTeamColoredName(src.player)
	
	--get inflictor's target's name if the source exists (can't use source for some reason)
	if inflictor and inflictor.valid and inflictor.target and inflictor.target.valid and inflictor.target.player
		srcname = getTeamColoredName(inflictor.target.player, true)
	end
	
	if p.mo.health > 0
		print(pname .. " was hit by " .. srcname .. possessiveFix(srcname) .. " electric bolt.")
	else
		print(pname .. " was zapped to death by " .. srcname .. possessiveFix(srcname) .. " electric bolt.")
	end
	return true
end, MT_SPYROELEC1)

--hit by charge attack or other spyro moves
addHook("HurtMsg", function(p, inflictor, src)
	local pname = getTeamColoredName(p)
	local srcname = "someone" --getTeamColoredName(src.player)
	
	--check if inflictor exists
	if inflictor and inflictor.valid and inflictor.player
	srcname = getTeamColoredName(inflictor.player)
	
		--if charging
		if (inflictor.player.charging or inflictor.player.aircharging)
			
			if p.mo.health > 0
				print(pname .. " was hit by " .. srcname .. possessiveFix(srcname) .. " charge attack.")
			else
				print(pname .. " was killed by " .. srcname .. possessiveFix(srcname) .. " charge attack.")
			end
			return true
		end
		/*
		--if headbashing
		if (inflictor.player.bashing)
			
			if p.mo.health > 0
				print(pname .. " was hit by " .. srcname .. "'s headbash.")
			else
				print(pname .. " was killed by " .. srcname .. "'s headbash.")
			end
			return true
		end
		*/
	end
	return nil
end, MT_PLAYER)

--make absolutely sure spyro's snowflake code does not run
addHook("PlayerSpawn", function(p)
	if CBW_Battle
		COM_BufInsertText(p, "spyrosnowflakecode 0")
	end
end)