--FUNCTIONS AND OTHER INITIALIZATION--


--print warning if old version
if not VERSION == 202
or SUBVERSION < 6
	error("\137SPYRO: Unknown or unsupported version. Please use the latest version of SRB2. Expected v2.2.6 or newer, got " .. VERSIONSTRING, 0)
end

----------------
--FREESLOT/SOC--
----------------
freeslot(
--glide/hover/bash
"S_PLAY_GLIDE_LOW",
"SPR2_GLDL",
"sfx_hover", 
"sfx_basha",
--charge
"S_PLAY_FALLCHARGE", 
"SPR2_RUNF", 
"S_PLAY_SWIMCHARGE", 
"SPR_SCHG", 
"sfx_charge", 
"sfx_scharg", 
"sfx_sbonk",
--battleheal sprite override
"SPR2_HEAL",
--fire
"MT_SPYROFIRE", 
"S_SPYROFIRE", 
"MT_SPYROBUBBLE", 
"S_SPYROBUBBLE", 
"SPR_SPYF", 
"MT_SPYROFIRESUPER", 
"S_SPYROFIRESUPER",
"S_SPYROFIRESUPER_XPLD1", 
"S_SPYROFIRESUPER_XPLD2", 
"S_SPYROFIRESUPER_XPLD3",
"MT_SPYROFIRESUPER_FLAMES", 
"S_SPYROFIRESUPER_FLAMES", 
"S_SPYROFIRESUPER_FLAMES_DIE",
"MT_SPYROFIRESUPER_FLAMEREST", 
"S_SPYROFIRESUPER_FLAMEREST",
"MT_SPYROFIRESUPER_FLAME1",
"S_SPYROFIRESUPER_FLAME1",
"SPR_SPSF", 
"MT_SPYROELEC1", 
"S_SPYROELEC1", 
"MT_SPYROELEC2", 
"S_SPYROELEC2", 
"SPR_SZAP", 
"sfx_flame", 
"sfx_sflame", 
"sfx_barexp", 
"sfx_flerr", 
"sfx_selec1", 
"sfx_selec2", 
"sfx_echarg"
)

 --pallete
--can't get a good purple color
--"pruple" has bad contrast
--"dusk" is as good it's gonna get
freeslot("SKINCOLOR_PURPLEDUSK")
skincolors[SKINCOLOR_PURPLEDUSK] = {
	name = "Purpledusk",
	--ramp = {252, 160, 170, 171, 172, 172, 196, 196, 196, 196, 197, 197, 198, 198, 198, 199},
	--ramp = {146, 147, 148, 148, 172, 173, 173, 173, 174, 174, 175, 175, 169, 169, 253, 253}, --dusk
	--ramp = {146, 147, 148, 148, 172, 173, 173, 173, 174, 174, 168, 168, 169, 169, 253, 253},
	--ramp = {192,180,181,181,182,182,183,183,184,184,185,185,186,186,187,199},
	--ramp = {160,161,193,194,172,172,172,166,166,167,167,167,168,168,168,169},
	ramp = {160,161,162,162,163,163,173,173,174,174,175,175,169,169,253,253},
	invcolor = SKINCOLOR_OLIVE,
	invshade = 65,
	chatcolor = V_PURPLEMAP,
	accessible = true
}


--glide/hover/bash
sfxinfo[sfx_hover].caption = "Wing flap"
sfxinfo[sfx_hover].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_basha].caption = "Head bashing"
sfxinfo[sfx_basha].flags = SF_TOTALLYSINGLE
--charge
sfxinfo[sfx_charge].caption = "Charging"
sfxinfo[sfx_scharg].caption = "Supercharging"
sfxinfo[sfx_sbonk].caption = "BONK!"
--fire
sfxinfo[sfx_flame].caption = "Flame breath"
sfxinfo[sfx_flame].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_sflame].caption = "Superflame breath"
sfxinfo[sfx_sflame].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_barexp].caption = "Superflame explosion"
sfxinfo[sfx_barexp].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_flerr] = {true, 64, SF_TOTALLYSINGULAR}
sfxinfo[sfx_flerr].caption = "Blocked attack"
sfxinfo[sfx_selec1].caption = "Electric zap"
sfxinfo[sfx_selec2].caption = "Powerful electric zap"
sfxinfo[sfx_echarg].caption = "Electrical Charging"
sfxinfo[sfx_echarg].flags = SF_TOTALLYSINGLE

--glide/hover/bash
states[S_PLAY_GLIDE_LOW] = {
		sprite = SPR_PLAY,
		frame = SPR2_GLDL,
		tics = -1,
		nextstate = S_PLAY_FALL
}

--charge
states[S_PLAY_FALLCHARGE] = {
		sprite = SPR_PLAY,
		--sprite2 = SPR2_RUNF,
		frame = SPR2_RUNF,
		tics = -1,
		nextstate = S_PLAY_FALL
}
//states[S_PLAY_FALLCHARGE] = {SPR_PLAY, SPR2_RUNF, -1, nil, 0, 0, S_PLAY_FALL}

states[S_PLAY_SWIMCHARGE] = {
		--sprite = SPR_PLAY,
		sprite = SPR_SCHG,
		--frame = FF_ANIMATE|SPR2_SCHG,
		frame = FF_ANIMATE|FF_GLOBALANIM|A,
		tics = 4,
		var1 = 4,
		var2 = 2,
		nextstate = S_PLAY_SWIM
}

--fire
mobjinfo[MT_SPYROFIRE] = {
        doomednum = -1,
        spawnstate = S_SPYROFIRE,
        spawnhealth = 1,
        seestate = S_NULL,
        seesound = sfx_None,
        reactiontime = 0,
        attacksound = sfx_None,
        painstate = S_NULL,
        painchance = 0,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,
        --deathstate = S_XPLD2,
		deathstate = S_SMOKE1,
        xdeathstate = S_NULL,
        deathsound = sfx_None,
        speed = 40*FRACUNIT,
        radius = 31*FRACUNIT,
        height = 31*FRACUNIT,
        dispoffset = 0,
        mass = 0,
        damage = 0,
        activesound = sfx_None,
        flags = MF_NOGRAVITY|MF_FIRE,
        raisestate = S_NULL
}

states[S_SPYROFIRE] = {
        sprite = SPR_SPYF,
        frame = FF_FULLBRIGHT|A,
        tics = 10,
        nextstate = S_NULL
}

mobjinfo[MT_SPYROBUBBLE] = {
        doomednum = -1,
        spawnstate = S_SPYROBUBBLE,
        spawnhealth = 1,
        seestate = S_NULL,
        seesound = sfx_None,
        reactiontime = 0,
        attacksound = sfx_None,
        painstate = S_NULL,
        painchance = 0,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,
        deathstate = S_NULL,
        xdeathstate = S_NULL,
        deathsound = sfx_None,
        speed = 40*FRACUNIT,
        radius = 31*FRACUNIT,
        height = 31*FRACUNIT,
        dispoffset = 0,
        mass = 0,
        damage = 0,
        activesound = sfx_None,
        flags = MF_NOBLOCKMAP|MF_NOGRAVITY,
        raisestate = S_NULL
}

states[S_SPYROBUBBLE] = {
        sprite = SPR_SPYF,
        frame = B,
        tics = 10,
        nextstate = S_NULL
}

mobjinfo[MT_SPYROFIRESUPER] = {
		doomednum = -1,
        spawnstate = S_SPYROFIRESUPER,
        spawnhealth = 1,
        seestate = S_NULL,
        seesound = sfx_None,
        reactiontime = 0,
        attacksound = sfx_None,
        painstate = S_NULL,
        painchance = 0,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,
        --deathstate = S_CYBRAKDEMONMISSILE_EXPLODE1, --S_XPLD1,	
		deathstate = S_SPYROFIRESUPER_XPLD1, --S_XPLD1,	
        xdeathstate = S_NULL,
        deathsound = sfx_barexp,
        speed = 40*FRACUNIT,
        radius = 31*FRACUNIT,
        height = 31*FRACUNIT,
        dispoffset = 0,
        mass = 0,
        damage = 36*FRACUNIT,
        activesound = sfx_None,
        flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_MISSILE|MF2_EXPLOSION|MF2_SUPERFIRE,
        raisestate = S_NULL	
}

states [S_SPYROFIRESUPER] = {
		sprite = SPR_SPSF,
        frame = FF_FULLBRIGHT|FF_TRANS10|FF_ANIMATE|A,
        tics = -1,
		var1 = 7,
		var2 = 3,
        nextstate = S_NULL
}

states [S_SPYROFIRESUPER_XPLD1] = {
		sprite = SPR_RCKT,
        frame = FF_FULLBRIGHT|B,
        tics = 8,
		action = A_Explode,
		var1 = 0,
		var2 = 0,
        nextstate = S_SPYROFIRESUPER_XPLD2
}

states [S_SPYROFIRESUPER_XPLD2] = {
		sprite = SPR_RCKT,
        frame = FF_FULLBRIGHT|C,
        tics = 6,
		action =A_NapalmScatter,
		--var1 = MT_CYBRAKDEMON_NAPALM_FLAMES+(6<<16),
		var1 = MT_SPYROFIRESUPER_FLAMES+(6<<16),
		--var1 = MT_SPINFIRE+(6<<16),
		var2 = 32+(16<<16) ,
        nextstate = S_SPYROFIRESUPER_XPLD3
}

states [S_SPYROFIRESUPER_XPLD3] = {
		sprite = SPR_RCKT,
        frame = FF_FULLBRIGHT|D,
        tics = 4,
		--action =A_NapalmScatter,
		var1 = 0,
		var2 = 0,
        nextstate = S_NULL
}

mobjinfo[MT_SPYROFIRESUPER_FLAMES] = {
		doomednum = -1,
        spawnstate = S_SPYROFIRESUPER_FLAMES,
        spawnhealth = 1000,
        seestate = S_NULL,
        seesound = sfx_None,
        reactiontime = 8,
        attacksound = sfx_None,
        painstate = S_NULL,
        painchance = 0,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,	
		deathstate = S_SPYROFIRESUPER_FLAMES_DIE,	
        xdeathstate = S_NULL,
        deathsound = sfx_None,
        speed = 10*FRACUNIT,
        radius = 24*FRACUNIT,
        height = 24*FRACUNIT,
        dispoffset = 0,
        mass = 100,
        damage = 1,
        activesound = sfx_None,
        flags = MF_MISSILE|MF_FIRE,
        raisestate = S_NULL	
}

states [S_SPYROFIRESUPER_FLAMES] = {
		sprite = SPR_SFLM,
        frame = FF_FULLBRIGHT|FF_ANIMATE|A,
        tics = 12,
		var1 = 5,
		var2 = 2,
        nextstate = S_SPYROFIRESUPER_FLAMES_DIE
}

states [S_SPYROFIRESUPER_FLAMES_DIE] = {
		sprite = SPR_SFLM,
        frame = FF_FULLBRIGHT|A,
        tics = 0,
		action = A_SpawnObjectRelative,
		var1 = 0,
		var2 = MT_SPYROFIRESUPER_FLAMEREST,
		--var2 = MT_SPYROFIRESUPER_FLAMEREST,
		--var2 = MT_SPINFIRE,
        nextstate = S_NULL
}

mobjinfo[MT_SPYROFIRESUPER_FLAMEREST] = {
        doomednum = -1,
        --spawnstate = S_SPYROFIRESUPER_FLAMEREST,
		spawnstate = S_CYBRAKDEMONFLAMEREST,
		--spawnstate = S_SPINFIRE1,
        spawnhealth = 1000,
        seestate = S_NULL,
        seesound = sfx_None,
        reactiontime = 8,
        attacksound = sfx_None,
        painstate = S_NULL,
        painchance = 0,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,
        deathstate = S_NULL,
        xdeathstate = S_NULL,
        deathsound = sfx_None,
        speed = 20*FRACUNIT,
        radius = 24*FRACUNIT,
        height = 24*FRACUNIT,
        dispoffset = 0,
        mass = 0,
        damage = 1,
        activesound = sfx_None,
		flags = MF_NOBLOCKMAP|MF_FIRE|MF_RUNSPAWNFUNC,
        --flags = MF_NOBLOCKMAP|MF_FIRE|MF_MISSILE|MF_SCENERY|MF_RUNSPAWNFUNC,
		--flags = MF_FIRE|MF_PAIN|MF_RUNSPAWNFUNC,
        raisestate = S_NULL
}

states [S_SPYROFIRESUPER_FLAMEREST] = {
		sprite = SPR_FLAM,
        frame = FF_FULLBRIGHT|D,
        tics = 0,
		action = A_SetFuse,
		var1 = 8*TICRATE,
		var2 = 0,
        nextstate = S_FLAME
}

mobjinfo[MT_SPYROFIRESUPER_FLAME1] = {
        doomednum = -1,
        spawnstate = S_FLAME,
        spawnhealth = 3,
        seestate = S_NULL,
        seesound = sfx_None,
        reactiontime = 0,
        attacksound = sfx_None,
        painstate = S_NULL,
        painchance = 0,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,
        deathstate = S_NULL,
        xdeathstate = S_NULL,
        deathsound = sfx_None,
        speed = 0,
        radius = 8*FRACUNIT,
        height = 32*FRACUNIT,
        dispoffset = 0,
        mass = 0,
        damage = 0,
        activesound = sfx_None,
        flags = MF_NOBLOCKMAP|MF_FIRE|MF_MISSILE|MF_NOGRAVITY|MF_SCENERY,
        raisestate = S_NULL
}

mobjinfo[MT_SPYROELEC1] = {
        doomednum = -1,
        spawnstate = S_SPYROELEC1,
        spawnhealth = 3,
        seestate = S_NULL,
        seesound = sfx_None,
        reactiontime = 0,
        attacksound = sfx_None,
        painstate = S_NULL,
        painchance = 0,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,
        deathstate = S_WATERZAP,
        xdeathstate = S_NULL,
        deathsound = sfx_None,
        speed = 45*FRACUNIT,
        radius = 17*FRACUNIT,
        height = 17*FRACUNIT,
        dispoffset = 0,
        mass = 0,
        damage = 0,
        activesound = sfx_None,
        flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_MISSILE,
        raisestate = S_NULL
}

states [S_SPYROELEC1] = {
	sprite = SPR_SZAP,
	frame = FF_FULLBRIGHT|FF_ANIMATE|A,
	tics = 15,
	var1 = 3,
	var2 = 2,
	netxstate = S_NULL
}

mobjinfo[MT_SPYROELEC2] = {
        doomednum = -1,
        spawnstate = S_SPYROELEC2,
        spawnhealth = 1,
        seestate = S_NULL,
        seesound = sfx_None,
        reactiontime = 0,
        attacksound = sfx_None,
        painstate = S_NULL,
        painchance = 0,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,
        deathstate = S_WATERZAP,
        xdeathstate = S_NULL,
        deathsound = sfx_None,
        speed = 45*FRACUNIT,
        radius = 31*FRACUNIT,
        height = 31*FRACUNIT,
        dispoffset = 0,
        mass = 0,
        damage = 0,
        activesound = sfx_None,
        flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_MISSILE,
        raisestate = S_NULL
}

states [S_SPYROELEC2] = {
	sprite = SPR_SZAP,
	frame = FF_FULLBRIGHT|FF_ANIMATE|E,
	tics = -1,
	var1 = 3,
	var2 = 2,
	netxstate = S_NULL
}

----------------------------
--CONSOLE/GLOBAL VARIABLES--
----------------------------

--this lets others know that spyro is present, for addon integration shenanigans
rawset(_G, "N1024_SPYRO", {})
N1024_SPYRO = true

--you're winner
rawset(_G, "cv_winner", CV_RegisterVar({
	name = "winner",
	defaultvalue = "0",
	flags = CV_NETVAR,
	PossibleValue = {On = 1, Off = 0},
	Func = 0,
}))

/*--for when you want to just end it all
COM_AddCommand("justfuckmyshitup", function(fuck)
	if ~true
		print("FUCK THAT WAS SUPPOSED TO SIGSEV")
	end
end)
*/

/*--charge speed console variable (unused)
rawset(_G, "cv_chgspeed", CV_RegisterVar({
    name = "chgspeed",
    defaultvalue = "25",
    flags = CV_NETVAR,
    Func = 0,
}))
*/
--console variable to determine playstyle (tweaked physics, etc.) (UNUSED)
rawset(_G, "cv_playstyle", CV_RegisterVar({
    name = "playstyle",
    defaultvalue = "0",
    flags = 0,
    PossibleValue = {Original = 0, Reignited = 1},
    Func = 0,
}))

--console variable to enable bash-rollout move
rawset(_G, "cv_rolloutavailable", CV_RegisterVar({
	name = "rolloutavailable",
	defaultvalue = "0",
	flags = 0,
	PossibleValue = {Yes = 1, No = 0},
	Func = 0,
}))

--console variable to enable bonking against walls
rawset(_G, "cv_bonk", CV_RegisterVar({
	name = "bonk",
	defaultvalue = "1",
	flags = 0,
	PossibleValue = {Yes = 1, No = 0},
	Func = 0,
}))

--speed multiplier cvar
rawset(_G, "cv_spyrospeedmul", CV_RegisterVar({
	name = "spyrospeedmul",
	defaultvalue = "1.0",
	flags = CV_FLOAT|CV_NETVAR,
	Func = 0,
}))

--charge turn nerf cvar
rawset(_G, "cv_spyrochargeturn", CV_RegisterVar({
	name = "spyrochargeturn",
	defaultvalue = "1",
	PossibleValue = {Yes = 1, No = 0},
	flags = CV_NETVAR,
	--Func = 0,
}))

--flame nerf cvar
rawset(_G, "cv_spyroholdflame", CV_RegisterVar({
	name = "spyroholdflame",
	defaultvalue = "0",
	PossibleValue = {Yes = 1, No = 0},
	flags = CV_NETVAR,
}))

--crash course console help printer console command
COM_AddCommand("spyrohelp", function(p, arg)
	if arg == "hints"
	or arg == "hints+sparx"
		CONS_Printf(p, "\137Hints & Tips When Playing as Spyro:")
		CONS_Printf(p, "\137Spyro \128is a very slow character compared to others, use his movement abilities to your advantage.")
		CONS_Printf(p, "\137Spyro\128's initial glide speed is fairly slow, however it's \131uncapped\128. \142Charge\128 then quickly get into a \136glide\128 if you want extra speed.")
		CONS_Printf(p, "\137Spyro \128can \142charge\128 right after a hover, use this if you want to feel fast.")
		if p.mo and not p.mo.sparx
		or arg ~= "hints+sparx"
			CONS_Printf(p, "\133Sparx is not here to help.\128 Try not to drown or get hit without any rings!")
		elseif p.mo and p.mo.sparx
		or arg == "hints+sparx"
			CONS_Printf(p, "\130Sparx\128 can point to any nearby gems by pressing \143TOSS FLAG\128")
			CONS_Printf(p, "\133Sparx cannot collect rings for you.\128 You'll have to do that yourself.")
		end
	else
		CONS_Printf(p, "\137Playing as Spyro:")
		CONS_Printf(p, "\137Spyro\128 can glide by pressing \136JUMP\128 while in the air. To hover press \131CUSTOM 2\128.")
		CONS_Printf(p, "\137Spyro\128 can breathe fire by holding \133CUSTOM 1\128. To charge ahead press and hold \142SPIN\128. Use these to defeat enemies, however \129some cannot be flammed or charged\128.")
		CONS_Printf(p, "\137Spyro\128 can headbash by pressing \131CUSTOM 2\128 while in the air or underwater. This can break through bustable floors.")
		if cv_rolloutavailable.value == 1
			CONS_Printf(p, "\137Spyro\128 can perform a short roll after a headbash by holding the \142SPIN\128 button while headbashing. This can be used to get under low gaps.")
		end
		CONS_Printf(p, "\137Spyro\128's abilities can be altered with certain \130shields\128, try out his diferent moves to see what these shields can do!")
		CONS_Printf(p, "\137Spyro\128 can swim, press and hold \136JUMP\128 while underwater to swim upwards. He can also charge underwater too.")
		if p.mo and p.mo.sparx
		or arg == "+sparx"
			CONS_Printf(p, "\130Sparx\128, your dragonfly buddy, can pick up nearby gems while protecting you from damage.")
			CONS_Printf(p, "\130Sparx\128's color determines his health, keep him in shape by feeding him butterflies that are released from fodder or some enemies.")
		end
		CONS_Printf(p, "Type '\131spyrohelp \130hints\128' into the console for additional hints and tips.")
	end
end, COM_LOCAL)

-------------------------------------
--CHARGEABLE/FLAMMABLE ENEMY TABLES--
-------------------------------------

--states that spyro shoudln't be in when determining what actions to perform
rawset(_G, "bannedStates", {
	S_PLAY_PAIN, 
	S_PLAY_STUN, 
	S_PLAY_DEAD, 
	S_PLAY_DRWN, 
	S_PLAY_SUPER_TRANS1, 
	S_PLAY_SUPER_TRANS2, 
	S_PLAY_SUPER_TRANS3, 
	S_PLAY_SUPER_TRANS4, 
	S_PLAY_SUPER_TRANS5, 
	S_PLAY_SUPER_TRANS6, 
	S_PLAY_GASP
})             --
rawset(_G, "bannedAnimStates", {
	S_PLAY_WALK, 
	S_PLAY_FLY, 
	S_PLAY_SWIM, 
	S_PLAY_GLIDE, 
	S_PLAY_DASH, 
	S_PLAY_FALL
})

--objects that can be flamed (LEGACY)
rawset(_G, "flammableEnemies", {
	MT_PLAYER, 
	MT_BLUECRAWLA, 
	MT_REDCRAWLA, 
	MT_GFZFISH, 
	MT_REDBUZZ, 
	MT_GOLDBUZZ, 
	MT_JETTBOMBER, 
	MT_JETTGUNNER, 
	MT_CRAWLACOMMANDER, 
	MT_SKIM, 
	MT_POPUPTURRET, 
	MT_SNAILER, 
	MT_VULTURE, 
	MT_POINTY, 
	MT_ROBOHOOD, 
	MT_EGGGUARD, 
	MT_GSNAPPER, 
	MT_MINUS, 
	MT_PTERABYTE, 
	MT_DRAGONBOMBER, 
	MT_TNTBARREL, 
	MT_PENGUINATOR, 
	MT_POPHAT, 
	MT_CACOLANTERN, 
	MT_HANGSTER, 
	MT_HIVEELEMENTAL, 
	MT_BUMBLEBORE, 
	--MT_METALSONIC_BATTLE, 
	MT_CANARIVORE, 
	MT_GOOMBA, 
	MT_BLUEGOOMBA, 
	MT_DETON
})
--objects that cannot be flamed, for the ping sound effect
rawset(_G, "nonflammableEnemies", {
	MT_SPINCUSHION, 
	MT_CRUSHSTACEAN, 
	MT_BANPYURA, 
	MT_JETJAW, 
	MT_FACESTABBER, 
	MT_UNIDUS, 
	MT_SPRINGSHELL, 
	MT_YELLOWSHELL, 
	MT_PYREFLY, 
	MT_SPINBOBERT, 
	MT_EGGSHIELD,
	MT_METALSONIC_BATTLE,
	"metalsonic",
	"rocketmetal",
	"mechasonic",
	"flarethelizard",
	"fire"
})
--objects that can be charged into (LEGACY)
rawset(_G, "chargeableEnemies", {
	MT_PLAYER, 
	MT_BLUECRAWLA, 
	MT_REDCRAWLA, 
	MT_CRAWLACOMMANDER,
	MT_GFZFISH, 
	MT_JETTBOMBER, 
	MT_JETTGUNNER, 
	MT_SKIM, 
	MT_POPUPTURRET, 
	MT_SPINCUSHION, 
	MT_CRUSHSTACEAN, 
	MT_BANPYURA, 
	MT_JETJAW, 
	MT_VULTURE, 
	MT_POINTY, 
	MT_ROBOHOOD, 
	MT_FACESTABBER, 
	MT_EGGGUARD, 
	MT_SPRINGSHELL, 
	MT_YELLOWSHELL, 
	MT_UNIDUS, 
	MT_PYREFLY, 
	MT_PTERABYTE, 
	MT_DRAGONBOMBER, 
	MT_TNTBARREL, 
	MT_PENGUINATOR, 
	MT_POPHAT, 
	MT_SPINBOBERT, 
	MT_CACOLANTERN, 
	MT_HANGSTER, 
	MT_HIVEELEMENTAL, 
	MT_BUMBLEBORE, 
	MT_BUGGLE, 
	MT_FANG, 
	MT_CANARIVORE, 
	MT_GOOMBA, 
	MT_BLUEGOOMBA, 
	MT_METALSONIC_BATTLE, 
	MT_EGGMOBILE, 
	MT_EGGMOBILE2, 
	MT_EGGMOBILE3, 
	MT_EGGMOBILE4, 
	MT_EGGSHIELD
})
--objects that cannot be charged into
rawset(_G, "nonchargeableEnemies", {
	MT_REDBUZZ, 
	MT_GOLDBUZZ, 
	MT_GSNAPPER, 
	MT_BLACKEGGMAN, 
	MT_CYBRAKDEMON
})
--objects that will recoil you when charged into
rawset(_G, "chargeableBonk", {
	MT_CRAWLACOMMANDER, 
	MT_FACESTABBER, 
	MT_METALSONIC_BATTLE, 
	MT_BLACKEGGMAN, 
	MT_CYBRAKDEMON,
	"metalsonic",
	"brakeggman"
})
--objects that cannot be zapped, for the ping sound effect
rawset(_G, "nonzappableEnemies", {
	"inazuma",
	"pulseman"
})

--objects that can be headbashed (unused)
rawset(_G, "bashableEnemies", {

})

--textures that can be climbed on (maybe, climbing is not in scope)
rawset(_G, "climbableWall", {
	GFZVINES, 
	GFZVCRACK, 
	PIPE2, 
	PIPE3, 
	WHZFLR16, 
	WHZFLR17, 
	DSZ10, 
	DSZ11, 
	DSZ1, 
	DSZ2, 
	DSZ4M, 
	DSZ5M, 
	DSZ6M, 
	DSZ7M, 
	DSZ9M, 
	DEEPSE2W, 
	SCREEN01, 
	LIBRARY1, 
	LIBRARY2, 
	LIBRARY3, 
	LIBRARY4, 
	LIBRARY5, 
	LIBRARY6, 
	LIBRARY7, 
	LIBRARY8, 
	LIBRARYB, 
	LIBRARYC, 
	LIBRARYD, 
	LIBRARYE, 
	LIBRARYF, 
	LIBRARYG, 
	LIBRARYH, 
	LIBRARYI, 
	WEBB1, 
	WEBB2, 
	LFZWALL3, 
	MMB4, 
	MMB8
})


-------------
--FUNCTIONS--
-------------

--unset thing pos z, to avoid collision checks when moving in the z direction 
local function FreeSetZ(mo, newz) --(mobj_t, integer)
    local clip = (mo.flags & MF_NOCLIPTHING) ^^ MF_NOCLIPTHING

    mo.flags = $ | clip
    mo.z = newz
    mo.flags = $ & ~clip
end

--checks if a constant exitst via protected call shenanigans
--usefull for checking the existance of MT_* objects without throwing a runtime
local function constantExists(constant) --string constant (wrap it "quotes")
    local func = function(constant)
        local v = _G[constant]
    end
    return pcall(func, constant)
end

rawset(_G, "constantExists", constantExists)

--check if a value is in a table (though this was built into srb2)
--if not valueInTable
rawset(_G, "valueInTable", function(value, list) --(any var type(MT_* constant prefered), table)
	for key,item in ipairs(list)
		if item == value
			return true
		end
	end
	return false
end)
--else
--	print ("\130WARNING\128:\137SPYRO: Global function 'valueInTable' already initialized! Some features may not work as intended if function works differently from Spyro's function")
--end
/*
--P_DoPlayerPain function 
--but without the iframes or adding to timeshit
local function P_DoPlayerPainNoIframe(p, src, inflictor, ticmod)
	if ticmod == nil then ticmod = p.powers[pw_flashing] end
	P_DoPlayerPain(p, src, inflictor)
	p.powers[pw_flashing] = ticmod
	p.timeshit = $ -1
	ticmod = 0
end
rawset(_G, "P_DoPlayerPainNoIframe", P_DoPlayerPainNoIframe)
*/
rawset(_G, "P_DoPlayerPainNoIframe", function(p, src, inflictor, tic)
	if p.powers[pw_carry] == CR_ROPEHANG then p.mo.tracer = nil end
	
	local ang = ANG1
	p.fallbackspeed = 0
	
	P_ResetPlayer(p)
	
	p.mo.state = p.mo.info.painstate
	
	if p.mo.eflags & MFE_VERTICALFLIP
		FreeSetZ(p.mo, p.mo.z - 1)
	else
		FreeSetZ(p.mo, p.mo.z + 1)
	end
	
	if p.mo.eflags & MFE_UNDERWATER
		P_SetObjectMomZ(p.mo, FixedDiv(10511*FRACUNIT,2600*FRACUNIT), false)
	else
		P_SetObjectMomZ(p.mo, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
	end
	
	if inflictor
		if inflictor.type == MT_WALLSPIKE
			ang = inflictor.angle
		else
			ang = R_PointToAngle2(inflictor.x - inflictor.momx, inflictor.y - inflictor.momy, p.mo.x - p.mo.momx, p.mo.y - p.mo.momy)
		end
		
		--explosive/rail rings have bigger knockback
		if (inflictor.flags2 & MF2_SCATTER) and source
			local dist P_AproxDistance(P_AproxDistance(src.x - p.mo.x, src.y - p.mo.y), src.z - p.mo.z)
			dist = FixedMul(128*FRACUNIT, inflictor.scale) - dist/4
			
			if dist < FixedMul(4*FRACUNIT, inflictor.scale)
				dist = FixedMul(4*FRACUNIT, inflictor.scale)
			end
			
			p.fallbackspeed = dist
		elseif (inflictor.flags2 & MF2_EXPLOSION)
			if (inflictor.flags2 & MF2_RAILRING)
				p.fallbackspeed = FixedMul(38*FRACUNIT, inflictor.scale); --7x
			else
				p.fallbackspeed = FixedMul(30*FRACUNIT, inflictor.scale); --5x
			end
		elseif (inflictor.flags2 & MF2_RAILRING)
			p.fallbackspeed = FixedMul(45*FRACUNIT, inflictor.scale); --4x
		else
			p.fallbackspeed = FixedMul(4*FRACUNIT, inflictor.scale); --the usual amount of force
		end
	else
		if p.mo.momx or p.mo.momy
			ang = R_PointToAngle2(p.mo.momx, p.mo.momy, 0, 0)
		else
			ang = p.drawangle
		end
		p.fallbackspeed = FixedMul(4*FRACUNIT, p.mo.scale)
	end
	
	p.drawangle = ang + ANGLE_180
	P_InstaThrust(p.mo, ang, p.fallbackspeed)
	
	--point penalties (irrelevant, not bothering to implement)
	/*
	if (gametyperules & (GTR_TAG|GTR_HIDEFROZEN)) == GTR_TAG
	and (not(p.pflags & PF_GAMETYPEOVER) and not(p.pflags & PF_TAGIT))
		
	end
	*/
	
	--use custom tic
	if tic == nil then tic = p.powers[pw_flashing] end
	if p.powers[pw_flashing] < tic 
	and p.powers[pw_flashing] > 0
		p.powers[pw_flashing] = tic 
	end
	
	--don't add to timeshit
	--if p.timeshit ~= UINT8_MAX then p.timeshit = $ +1 end
end)

---------------------------
--VARIABLE INITIALIZATION--
---------------------------

/*
--footsteps
if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end

PlayerAnimInfo["spyro"] = {
	["runFrames"] = {0, 2},
	["walkFrames"] = {3, 4},
	["waitFrames"] = {0},
	["run"] = true,
	["walk"] = true,
	["idle"] = true,
	["wait"] = false,
	["superRun"] = true,
	["superWalk"] = true,
	["superIdle"] = true,
	["superWait"] = false,
	["feetType"] = 2 --internal hax of footsteps, to determine the kind of footstep sounds to play
}
*/
local function resetSpyro()
	for p in players.iterate
		if p.mo and p.mo.skin == "spyro"
			--initialize variables
			--if not p.varinit
			
				if p.carrytimeout == nil then p.carrytimeout = 0 end
				
				p.glidespeed = 20*FRACUNIT
				p.glideratio = 4*FRACUNIT --proper glide ratio is 20:4 or 5:1
				if p.glidecooldown == nil then p.glidecooldown = 0 end
				if p.bashready == nil then p.bashready = 7 end
				if p.hovering == nil then p.hovering = 0 end
				--p.glidectrl = 0
				--p.glideratio = 1*FRACUNIT
				
				if p.chargecooldown == nil then p.chargecooldown = 0 end
				p.walkspeed = 15*FRACUNIT
				p.chargespeed = 29*FRACUNIT
				p.airchargespeed = 22*FRACUNIT
				p.superchargespeed = 50*FRACUNIT
				p.normaljumpfactor = (11*FRACUNIT)/10
				p.chargejumpfactor = 1*FRACUNIT
				
				if p.sflamecooldown == nil then p.sflamecooldown = 0 end
				if p.shootcharge == nil then p.shootcharge = 0 end
				
				--p.varinit = true
			--end
		end
	end
end

addHook("ThinkFrame", resetSpyro)