--SNOWFLAKE CODE--

--level specific snowflake code shenanigans
--lore-wise the energy coming from the asteriod gives spyro addional powers

--snowflake code console variables
rawset(_G, "cv_spyrosnowflakecode", CV_RegisterVar({ --general snowflake code on/off switch
	name = "spyrosnowflakecode",
	defaultvalue = "1",
	flags = 0,
	PossibleValue = {On = 1, Off = 0},
	Func = 0,
}))
rawset(_G, "cv_spyrolvlmsrace", CV_RegisterVar({ --level number for the metalsonic race
    name = "spyrolvlmsrace",
    defaultvalue = "25",
    flags = CV_NETVAR,
    Func = 0,
}))
rawset(_G, "cv_spyrolvlmsboss", CV_RegisterVar({ --level number for the metalsonic boss
    name = "spyrolvlmsboss",
    defaultvalue = "26",
    flags = CV_NETVAR,
    Func = 0,
}))
rawset(_G, "cv_spyrolvlbrak", CV_RegisterVar({ --level number for the brak eggman boss
    name = "spyrolvlbrak",
    defaultvalue = "27",
    flags = CV_NETVAR,
    Func = 0,
}))

local function spyroSnowflakeCode()
	--text
	local msgHope = "\130You feel a power resonating within you, try to hold out a little longer!"
	local msgGetSupercharge = "\131The energy emitted from the Black Rock has givien you the Supercharge power!"
	local msgGetAttract = "\131The energy emitted from the Black Rock has givien you an Attract Shield!"
	local msgGetFlame = "\131The energy emitted from the Black Rock has givien you a Flame Shield!"
	
	if cv_spyrosnowflakecode.value ~= 1 then return end
	if CBW_Battle then return end
	
	for p in players.iterate
		if p.mo and p.mo.skin == "spyro"
		
			--map 25 is snowflaked to give spyro supercharge
			if gamemap == cv_spyrolvlmsrace.value
				p.powers[pw_sneakers] = 2
				
				if cv_spyrosnowflakecode.value ~= 1 then return end
				
				if p.messageget_sc == nil then p.messageget_sc = 35 end
				
				if p.messageget_sc == 0
					CONS_Printf(p, msgGetSupercharge) --lore-friendly reason :P
					CONS_Printf(p, msgGetSupercharge)
					CONS_Printf(p, msgGetSupercharge)
					CONS_Printf(p, msgGetSupercharge)
					p.messageget_sc = -1
				end
				
				if p.messageget_sc > 0 then p.messageget_sc = $ -1 end
			end
			
			--map 26 is snowflaked to give spyro an attraction shield
			if gamemap == cv_spyrolvlmsboss.value
				
				if cv_spyrosnowflakecode.value ~= 1 then return end
			
				--intial despair period by abusing uninitiated values
				if p.flakeshield == nil
					p.flakeshield = 10*TICRATE --10secs @35fps
					p.flakeshieldhint = 0
				end
				if p.powers[pw_shield] == 0 and (p.flakeshield <= 0)
					p.powers[pw_shield] = SH_ATTRACT
					P_SpawnShieldOrb(p)
					S_StartSound(p.mo, sfx_attrsg)
					p.flakeshield = 15*TICRATE --15secs @35fps, long enough that loosing the shield is punishing if you're not careful
					p.flakeshieldhint = $ + 1
					--if not p.messageget_shield1
						CONS_Printf(p, msgGetAttract)
						CONS_Printf(p, msgGetAttract)
						CONS_Printf(p, msgGetAttract)
						CONS_Printf(p, msgGetAttract)
						--p.messageget_shield1 = true
					--end
				end
				
				--print out hope
				if p.flakeshield == 5*TICRATE
					CONS_Printf(p, msgHope)
				end
				
				--decrement counter
				if p.flakeshield > 0 and (p.powers[pw_shield] ~= SH_ATTRACT)
					p.flakeshield = $ -1
				end
				
				--print out hint
				if p.flakeshieldhint >= 3
					CONS_Printf(p, "\130~~~~HINT!~~~~")
					CONS_Printf(p, "Metal Sonic is \129fireproof\128!")
					CONS_Printf(p, "Use the \142homing attack\128 or \130electric bolts\128 provided by the Attract Shield to force Metal Sonic's to evade!")
					CONS_Printf(p, "Then \133attack\128 Metal Sonic when he's vunerable!")
					p.flakeshieldhint = 0
				end
				--print (p.flakeshield)
			end
			
			--map 27 is snowflaked to give spyro superflame via flameshield, but only after getting hit.
			--it ain't much use when brak eggman can still be immune to projectiles, tho the flamshield can still protect spyro from most of the boss' attacks
			--perfect guard bonus or superflame? choices, choices...
			if gamemap == cv_spyrolvlbrak.value
			
				if cv_spyrosnowflakecode.value ~= 1 then return end
				
				--stop shield conflict, attract shield taskes priority
				if cv_spyrolvlbrak.value == cv_spyrolvlmsboss.value then return end
				
				--intial despair period by abusing uninitiated values
				if p.flakeshield == nil
					p.flakeshield = 10*TICRATE --10secs @35fps
					p.flakeshieldhint = 0
				end
				--give shield
				if p.powers[pw_shield] == 0 and (p.flakeshield <= 0) and p.timeshit > 0
					p.powers[pw_shield] = SH_FLAMEAURA
					P_SpawnShieldOrb(p)
					S_StartSound(p.mo, sfx_s3k3e)
					p.flakeshield = 15*TICRATE --15secs @35fps, long enough that loosing the shield is punishing if you're not careful
					--p.flakeshieldhint = $ + 1
					--if not p.messageget_shield1
						CONS_Printf(p, msgGetFlame)
						CONS_Printf(p, msgGetFlame)
						CONS_Printf(p, msgGetFlame)
						CONS_Printf(p, msgGetFlame) --can't be arsed to put these in for loops
						--p.messageget_shield1 = true
					--end
				end
				
				--print out hope
				if p.flakeshield == 5*TICRATE
					CONS_Printf(p, msgHope)
					--chatprintf(p, "You feel a power resonating within you, try to hold out a little longer!")
				end
				
				--decrement counter
				if p.flakeshield > 0 and (p.powers[pw_shield] ~= SH_FLAMEAURA) and p.timeshit > 0
					p.flakeshield = $ -1
				end
			end
		end
	end
end

addHook("ThinkFrame", spyroSnowflakeCode)

--boss metalsonic thinker override
addHook("BossThinker", function(boss)
	if boss and boss.valid
		--if boss.z <= boss.target.z 
		if P_IsObjectOnGround(boss.target)
		or boss.target.state == S_PLAY_PAIN
			boss.flags = $ & ~MF_SOLID
		else
			boss.flags = $ | MF_SOLID
		end
	end
end, MT_METALSONIC_BATTLE)

--(hopefully) not-so-laggy brak eggman's napalm flame thingy
addHook("MobjThinker", function(fire)
	--Flame Touches Ground and Gets Grounded (GoAnimate)
	if P_IsObjectOnGround(fire) and not fire.gnd
		fire.gnd = true --you're grounded
		P_SetObjectMomZ(fire, 1*FRACUNIT, false) --need zmom for later
	end
	
	--give missile flag when grounded and "starting to fall" otherwise the flame will die when it touches ground
	--also gives scenery flag for some (hopefully) extra performance
	if fire.momz == 0
	and fire.gnd
	and not (fire.flags & MF_SCENERY)
		fire.flags = $ | MF_SCENERY
		--fire.flags = $ | MF_MISSILE
	end
end, MT_CYBRAKDEMON_FLAMEREST)
/*
addHook("MobjThinker", function(fire)
	if fire.state == S_CYBRAKDEMONFLAMESHOT_DIE
		fire.state = S_SPYROFIRESUPER_FLAMES_DIE
	end
end, MT_CYBRAKDEMON_FLAMESHOT)
addHook("MobjThinker", function(fire)
	if fire.state == S_CYBRAKDEMONNAPALMFLAME_DIE
		fire.state = S_SPYROFIRESUPER_FLAMES_DIE
	end
end, MT_CYBRAKDEMON_NAPALM_FLAMES)
*/